
#include <stdio.h>
#include <assert.h>


#if 1
#define dprintf(x) printf x
#else
#define dprintf(x)
#endif

#define NAME "maze"

int main()
{
  FILE *fin = fopen(NAME ".in", "r");
  int w, h;
  enum { wmax = 75, hmax = 75 };
  int casenum = 1;

  while (fscanf(fin, "%d%d ", &w, &h) == 2 && w && h) {
    struct {
      int back : 1;
      int north : 1;
      int west : 1;
    } maze[wmax+1][hmax+1];
    int x, y;
    int maxcycle = 0;
    int numcycle = 0;

    printf("Maze #%d:\n", casenum);
    for (y = 0; y<=h; y++) {
      for (x = 0; x <= w; x++) {
	int ch = getc(fin);
	assert(ch == '/' || ch == '\\');
	maze[x][y].back = (ch == '\\');
	maze[x][y].north = (y == 0 || y == h);
	maze[x][y].west = (x == 0 || x == w);
      }
      fscanf(fin, " ");
    }

    for (;;) {
      int is_west = 0;
      int xstart, ystart;
      int thiscycle = 0;
      enum { sw, nw, ne, se } direc;

      for (y = 0; y<h; y++) {
	for (x = 0; x < w; x++) {
	  if (maze[x][y].west == 0 ||
	      maze[x][y].north == 0) {
	    goto found_it;
	  }
	}
      }
      break;

    found_it:
      if (maze[x][y].west) {
	is_west = 1;
      } else {
	is_west = 0;
      }
      xstart = x; ystart = y;

      while (is_west ? maze[x][y].west : maze[x][y].north) {
	thiscycle++;
	if (is_west) {
	  maze[x][y].west = 1;
	  if (maze[x][y].back) {
	    if (maze[x-1][y]
	  } else {
	  }
	} else {
	  maze[x][y].north = 1;
	}
      }

      if (xstart == x && ystart == y) {
	numcycles++;
	if (thiscycle > maxcycle) {
	  maxcycle = thiscycle;
	}
      }
    }

    if (numcycle)
      printf("%d Cycles; the longest has length %d.\n\n", numcycle, maxcycle);
    else
      printf("There are no cycles.\n");
  }
  return 0;
}
